/*
 *  Power BI Visualizations
 *
 *  Copyright (c) Microsoft Corporation
 *  All rights reserved.
 *  MIT License
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a copy
 *  of this software and associated documentation files (the ""Software""), to deal
 *  in the Software without restriction, including without limitation the rights
 *  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 *  copies of the Software, and to permit persons to whom the Software is
 *  furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in
 *  all copies or substantial portions of the Software.
 *
 *  THE SOFTWARE IS PROVIDED *AS IS*, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 *  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 *  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 *  THE SOFTWARE.
 */
var powerbi;
(function (powerbi) {
    var visuals;
    (function (visuals) {
        var BoxWhiskerChart1455240051538;
        (function (BoxWhiskerChart1455240051538) {
            var SelectionManager = visuals.utility.SelectionManager;
            var PixelConverter = jsCommon.PixelConverter;
            var BoxWhiskerTypeOptions;
            (function (BoxWhiskerTypeOptions) {
                (function (ChartType) {
                    ChartType[ChartType["MinMax"] = 0] = "MinMax";
                    ChartType[ChartType["Standard"] = 1] = "Standard";
                    ChartType[ChartType["IQR"] = 2] = "IQR";
                })(BoxWhiskerTypeOptions.ChartType || (BoxWhiskerTypeOptions.ChartType = {}));
                var ChartType = BoxWhiskerTypeOptions.ChartType;
            })(BoxWhiskerTypeOptions = BoxWhiskerChart1455240051538.BoxWhiskerTypeOptions || (BoxWhiskerChart1455240051538.BoxWhiskerTypeOptions = {}));
            var BoxWhiskerTypeOptions;
            (function (BoxWhiskerTypeOptions) {
                (function (MarginType) {
                    MarginType[MarginType["Small"] = 0] = "Small";
                    MarginType[MarginType["Medium"] = 1] = "Medium";
                    MarginType[MarginType["Large"] = 2] = "Large";
                })(BoxWhiskerTypeOptions.MarginType || (BoxWhiskerTypeOptions.MarginType = {}));
                var MarginType = BoxWhiskerTypeOptions.MarginType;
            })(BoxWhiskerTypeOptions = BoxWhiskerChart1455240051538.BoxWhiskerTypeOptions || (BoxWhiskerChart1455240051538.BoxWhiskerTypeOptions = {}));
            var BoxWhiskerChart = (function () {
                function BoxWhiskerChart(options) {
                    this.defaultFontFamily = "Segoe UI,wf_segoe-ui_normal,helvetica,arial,sans-serif";
                    this.staticColor = "#707070";
                    this.defaultFormatY = "#,0";
                    this.AxisSizeY = 40;
                    this.AxisSizeX = 20;
                    if (options) {
                        if (options.svg) {
                            this.svg = options.svg;
                        }
                        if (options.margin) {
                            this.margin = options.margin;
                        }
                    }
                }
                BoxWhiskerChart.prototype.converter = function (dataView, colors) {
                    if (!dataView || !dataView.matrix || !dataView.matrix.columns || !dataView.matrix.columns.root.children || !(dataView.matrix.columns.root.children.length > 0) || !(dataView.matrix.columns.root.children[0].levelValues) || !dataView.matrix.valueSources || !dataView.matrix.valueSources[0]) {
                        return {
                            dataPoints: [],
                            legendData: {
                                dataPoints: []
                            }
                        };
                    }
                    var categories = dataView.matrix.rows.root.children;
                    var dataPoints = [];
                    var legendData = {
                        fontSize: 8.25,
                        dataPoints: [],
                    };
                    if (dataView.matrix.rows.levels.length > 0) {
                        this.formatX = visuals.valueFormatter.create({
                            format: dataView.matrix.rows.levels[0].sources[0].format,
                            value: categories[0].value,
                            value2: categories[categories.length - 1].value,
                        });
                    }
                    else {
                        this.formatX = visuals.valueFormatter.createDefaultFormatter(null);
                    }
                    this.formatY = visuals.valueFormatter.create({
                        format: dataView.matrix.valueSources[0].format ? dataView.matrix.valueSources[0].format : this.defaultFormatY,
                        value: d3.max(dataView.matrix.rows.root.children, function (c) { return d3.max([c.values]); }),
                        value2: d3.min(dataView.matrix.rows.root.children, function (c) { return d3.min([c.values]); }),
                        precision: 3,
                    });
                    this.dataType = powerbi.ValueType.fromDescriptor(dataView.matrix.valueSources[0].type);
                    var hasStaticColor = categories.length > 15;
                    var staticColor = this.getStaticColor(this.dataView);
                    for (var i = 0, iLen = categories.length; i < iLen && i < 100; i++) {
                        var values = this.getValueArray(dataView.matrix.rows.root.children[i].values).filter(function (value) {
                            return value != null;
                        });
                        if (values.length === 0) {
                            break;
                        }
                        var selector, id;
                        if (categories.length === 1) {
                            id = visuals.SelectionId.createWithMeasure(dataView.matrix.valueSources[0].queryName);
                        }
                        else {
                            selector = { data: [categories[i].identity], };
                            id = new visuals.SelectionId(selector, false);
                        }
                        var sortedValue = values.sort(function (n1, n2) { return n1 - n2; });
                        var median = (sortedValue[Math.floor((sortedValue.length - 1) / 2)] + sortedValue[Math.ceil((sortedValue.length - 1) / 2)]) / 2;
                        var q1 = sortedValue.length === 3 ? 0 : (sortedValue.length - 1) / 4;
                        var q1LowValue = sortedValue[Math.floor(q1)];
                        var q1HighValue = sortedValue[Math.ceil(q1)];
                        var quartile1 = sortedValue.length <= 2 ? null : q1LowValue + ((q1 - Math.floor(q1)) * (q1HighValue - q1LowValue));
                        var q3 = sortedValue.length === 3 ? 2 : 3 * q1;
                        var q3LowValue = sortedValue[Math.floor(q3)];
                        var q3HighValue = sortedValue[Math.ceil(q3)];
                        var quartile3 = sortedValue.length <= 2 ? null : q3LowValue + (((3 * q1) - Math.floor(3 * q1)) * (q3HighValue - q3LowValue));
                        var minValue;
                        var maxValue;
                        var minValueLabel;
                        var maxValueLabel;
                        var whiskerType = this.getWhiskerType(this.dataView);
                        if (!quartile1 || !quartile3) {
                            whiskerType = 0 /* MinMax */;
                        }
                        switch (whiskerType) {
                            case 0 /* MinMax */:
                                minValue = sortedValue[0];
                                maxValue = sortedValue[sortedValue.length - 1];
                                minValueLabel = "Minimum";
                                maxValueLabel = "Maximum";
                                break;
                            case 1 /* Standard */:
                                var IQR = quartile3 - quartile1;
                                minValue = sortedValue.filter(function (value) { return value >= quartile1 - (1.5 * IQR); })[0];
                                maxValue = sortedValue.filter(function (value) { return value <= quartile3 + (1.5 * IQR); }).reverse()[0];
                                minValueLabel = "Minimum";
                                maxValueLabel = "Maximum";
                                break;
                            case 2 /* IQR */:
                                var IQR = quartile3 - quartile1;
                                minValue = quartile1 - (1.5 * IQR);
                                maxValue = quartile3 + (1.5 * IQR);
                                minValueLabel = "Q1 - 1.5 x IQR";
                                maxValueLabel = "Q3 + 1.5 x IQR";
                                break;
                            default:
                                minValue = sortedValue[0];
                                maxValue = sortedValue[sortedValue.length - 1];
                                minValueLabel = "Minimum";
                                maxValueLabel = "Maximum";
                                break;
                        }
                        var ttl = 0;
                        sortedValue.forEach(function (value) {
                            ttl += value;
                        });
                        var avgvalue = ttl / sortedValue.length;
                        dataPoints.push([]);
                        var outliers = this.getShowOutliers(this.dataView) ? sortedValue.filter(function (value) { return value < minValue || value > maxValue; }).filter(function (value, index, self) { return self.indexOf(value) === index; }) : [];
                        var colorHelper;
                        if (!hasStaticColor) {
                            colorHelper = new visuals.ColorHelper(this.colors, BoxWhiskerChart.properties.fill, this.colors.getColorByIndex(i).value);
                        }
                        dataPoints[i].push({
                            min: minValue,
                            max: maxValue,
                            quartile1: quartile1,
                            quartile3: quartile3,
                            median: median,
                            average: avgvalue,
                            samples: sortedValue.length,
                            category: i + 1,
                            outliers: outliers,
                            dataLabels: (this.getDataLabelShow(this.dataView)) ? [maxValue, minValue, avgvalue, median, quartile1, quartile3].filter(function (value, index, self) { return self.indexOf(value) === index; }).filter(function (value) {
                                return value != null;
                            }).map(function (dataPoint) {
                                return { value: dataPoint, x: 0, y: 0 };
                            }).concat(outliers.map(function (outlier) {
                                return { value: outlier, x: 0, y: 0 };
                            })) : [],
                            label: categories[0].value === undefined ? dataView.matrix.valueSources[0].displayName : this.formatX.format(categories[i].value),
                            identity: id,
                            color: hasStaticColor ? staticColor : colorHelper.getColorForSeriesValue(categories[i].objects, dataView.matrix.rows.root.childIdentityFields, categories[i].name),
                            tooltipInfo: [
                                {
                                    displayName: 'Group',
                                    value: categories[0].value === undefined ? dataView.matrix.valueSources[0].displayName : this.formatX.format(categories[i].value),
                                },
                                {
                                    displayName: '# Samples',
                                    value: visuals.valueFormatter.format(sortedValue.length, 'd', false),
                                },
                                {
                                    displayName: maxValueLabel,
                                    value: this.formatY.format(maxValue),
                                },
                                {
                                    displayName: 'Quartile 3',
                                    value: this.formatY.format(quartile3),
                                },
                                {
                                    displayName: 'Median',
                                    value: this.formatY.format(median),
                                },
                                {
                                    displayName: 'Average',
                                    value: this.formatY.format(avgvalue),
                                },
                                {
                                    displayName: 'Quartile 1',
                                    value: this.formatY.format(quartile1),
                                },
                                {
                                    displayName: minValueLabel,
                                    value: this.formatY.format(minValue),
                                }
                            ]
                        });
                    }
                    return {
                        dataPoints: dataPoints,
                        legendData: legendData
                    };
                };
                BoxWhiskerChart.prototype.init = function (options) {
                    var element = options.element;
                    this.hostServices = options.host;
                    this.colors = options.style.colorPalette.dataColors;
                    this.selectionManager = new SelectionManager({ hostServices: options.host });
                    if (!this.svg) {
                        this.svg = d3.select(element.get(0)).append('svg');
                    }
                    if (!this.margin) {
                        this.margin = BoxWhiskerChart.DefaultMargin;
                    }
                    this.svg.classed(BoxWhiskerChart.VisualClassName, true);
                    this.colors = options.style.colorPalette.dataColors;
                    this.mainGroupElement = this.svg.append("g");
                    this.axis = this.mainGroupElement.append("g").classed(BoxWhiskerChart.Axis.class, true);
                    this.axisX = this.axis.append("g").classed(BoxWhiskerChart.AxisX.class, true);
                    this.axisMajorGrid = this.axis.append("g").classed(BoxWhiskerChart.AxisMajorGrid.class, true);
                    this.axisMinorGrid = this.axis.append("g").classed(BoxWhiskerChart.AxisMinorGrid.class, true);
                    this.axisY = this.axis.append("g").classed(BoxWhiskerChart.AxisY.class, true);
                    this.chart = this.mainGroupElement.append("g").classed(BoxWhiskerChart.Chart.class, true);
                };
                BoxWhiskerChart.prototype.update = function (options) {
                    if (!options.dataViews || !options.dataViews[0]) {
                        this.chart.selectAll(BoxWhiskerChart.ChartNode.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisX.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisY.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisMajorGrid.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisMinorGrid.selector).remove();
                        return;
                    }
                    ;
                    var dataView = this.dataView = options.dataViews[0], data = this.data = this.converter(dataView, this.colors), dataPoints = data.dataPoints, duration = options.suppressAnimations ? 0 : 250;
                    this.viewport = {
                        height: options.viewport.height > 0 ? options.viewport.height : 0,
                        width: options.viewport.width > 0 ? options.viewport.width : 0
                    };
                    this.svg.attr({
                        'height': this.viewport.height,
                        'width': this.viewport.width
                    });
                    if (dataPoints.length === 0) {
                        this.chart.selectAll(BoxWhiskerChart.ChartNode.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisX.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisY.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisMajorGrid.selector).remove();
                        this.axis.selectAll(BoxWhiskerChart.AxisMinorGrid.selector).remove();
                        var warnings = [];
                        warnings.push({
                            code: 'DataSetIvalid',
                            getMessages: function () {
                                var visualMessage = {
                                    message: "Dataset is not valid or too small/empty for this visualization.",
                                    title: '',
                                    detail: '',
                                };
                                return visualMessage;
                            }
                        });
                        this.hostServices.setWarnings(warnings);
                        return;
                    }
                    // calculate AxisSizeX, AxisSizeY
                    this.AxisSizeX = powerbi.TextMeasurementService.estimateSvgTextHeight({
                        text: "XXXX",
                        fontFamily: this.defaultFontFamily,
                        fontSize: PixelConverter.fromPoint(this.getXAxisFontSize(this.dataView)),
                    });
                    var mainGroup = this.chart;
                    mainGroup.attr('transform', 'scale(1, -1)' + visuals.SVGUtil.translate(0, -(this.viewport.height - this.AxisSizeX)));
                    // calculate scalefactor
                    var stack = d3.layout.stack();
                    var layers = stack(dataPoints);
                    this.axisOptions = this.getAxisOptions(d3.min(layers, function (layer) {
                        return d3.min(layer, function (point) {
                            return d3.min([point.min, d3.min(point.outliers)]);
                        });
                    }), d3.max(layers, function (layer) {
                        return d3.max(layer, function (point) {
                            return d3.max([point.max, d3.max(point.outliers)]);
                        });
                    }));
                    this.AxisSizeY = powerbi.TextMeasurementService.measureSvgTextWidth({
                        text: this.formatY.format(this.axisOptions.max),
                        fontFamily: this.defaultFontFamily,
                        fontSize: PixelConverter.fromPoint(this.getYAxisFontSize(this.dataView)),
                    });
                    this.margin.top = powerbi.TextMeasurementService.measureSvgTextHeight({
                        text: this.formatY.format(this.axisOptions.max),
                        fontFamily: this.defaultFontFamily,
                        fontSize: PixelConverter.fromPoint(this.getYAxisFontSize(this.dataView)),
                    }) / 2.;
                    if (this.getDataLabelShow(this.dataView) && this.data.dataPoints.length > 0) {
                        var dataLabelTop = powerbi.TextMeasurementService.measureSvgTextHeight({
                            text: this.formatY.format(this.data.dataPoints[0][0].dataLabels[0].value),
                            fontFamily: this.defaultFontFamily,
                            fontSize: PixelConverter.fromPoint(this.getYAxisFontSize(this.dataView)),
                        }) / 2.;
                    }
                    var yScale = d3.scale.linear().domain([this.axisOptions.min, this.axisOptions.max]).range([this.margin.bottom, this.viewport.height - this.AxisSizeX - this.margin.top]);
                    var xScale = d3.scale.linear().domain([1, dataPoints.length + 1]).range([this.margin.left + this.AxisSizeY, this.viewport.width - this.margin.right]);
                    this.drawChart(dataPoints, xScale, yScale, duration);
                    this.drawAxis(dataPoints, yScale, duration);
                };
                BoxWhiskerChart.prototype.drawAxis = function (dataPoints, yScale, duration) {
                    var _this = this;
                    if ((this.axis.selectAll(BoxWhiskerChart.AxisX.selector)[0].length === 0) || (this.axis.selectAll(BoxWhiskerChart.AxisY.selector)[0].length === 0) || (this.axis.selectAll(BoxWhiskerChart.AxisMajorGrid.selector)[0].length === 0) || (this.axis.selectAll(BoxWhiskerChart.AxisMinorGrid.selector)[0].length === 0)) {
                        this.axisMajorGrid = this.axis.append("g").classed(BoxWhiskerChart.AxisMajorGrid.class, true);
                        this.axisMinorGrid = this.axis.append("g").classed(BoxWhiskerChart.AxisMinorGrid.class, true);
                        this.axisX = this.axis.append("g").classed(BoxWhiskerChart.AxisX.class, true);
                        this.axisY = this.axis.append("g").classed(BoxWhiskerChart.AxisY.class, true);
                    }
                    var textHelperX = this.axisX.append("text").classed("helperX", true).style("visibility", "hidden").style("font-size", this.getXAxisFontSize(this.dataView) + "px").text(dataPoints[0][0].label);
                    var textHelperY = this.axisY.append("text").classed("helperY", true).style("visibility", "hidden").style("font-size", this.getYAxisFontSize(this.dataView) + "px").text(this.formatY.format(this.axisOptions.max));
                    var yAxisLabelHeight = textHelperY.node().getBBox().height;
                    var xAxisLabelWidth = textHelperX.node().getBBox().width;
                    var xs = d3.scale.ordinal();
                    // Can we draw at least one X-axis label?
                    if (xAxisLabelWidth < (this.viewport.width - this.margin.right - this.margin.left - this.AxisSizeY)) {
                        var overSamplingX = 1;
                        var visibleDataPoints = dataPoints.filter(function (d, i) { return i % overSamplingX === 0; });
                        var totalXAxisWidth = d3.max(visibleDataPoints.map(function (d) { return textHelperX.text(d[0].label).node().getBBox().width + 2; } //margin
                        )) * visibleDataPoints.length;
                        while (totalXAxisWidth > (this.viewport.width - this.margin.right - this.margin.left - this.AxisSizeY)) {
                            overSamplingX += 1;
                            visibleDataPoints = dataPoints.filter(function (d, i) { return i % overSamplingX === 0; });
                            var totalXAxisWidth = d3.max(visibleDataPoints.map(function (d) { return textHelperX.text(d[0].label).node().getBBox().width + 2; } //margin
                            )) * visibleDataPoints.length;
                        }
                        xs.domain(dataPoints.map(function (values, index) {
                            return (index % overSamplingX === 0) ? values[0].label : null;
                        }).filter(function (d) { return d !== null; })).rangeBands([this.margin.left + this.AxisSizeY, this.viewport.width - this.margin.right]);
                    }
                    else {
                        xs.domain([]).rangeBands([this.margin.left + this.AxisSizeY, this.viewport.width - this.margin.right]);
                    }
                    var ys = yScale.range([this.viewport.height - this.AxisSizeX - this.margin.bottom, this.margin.top]);
                    var yAxisTicks = this.axisOptions.ticks;
                    if (yAxisLabelHeight < (this.viewport.height - this.AxisSizeX - this.margin.bottom - this.margin.top)) {
                        var totalYAxisHeight = yAxisTicks * yAxisLabelHeight;
                        while (totalYAxisHeight > this.viewport.height - this.AxisSizeX - this.margin.bottom - this.margin.top) {
                            yAxisTicks /= 2;
                            totalYAxisHeight = yAxisTicks * yAxisLabelHeight;
                        }
                    }
                    else {
                        yAxisTicks = 0;
                    }
                    var xAxisTransform = this.axisOptions.min > 0 ? ys(this.axisOptions.min) : this.axisOptions.max < 0 ? ys(this.axisOptions.min) : ys(0);
                    var xAxis = d3.svg.axis().scale(xs).orient("bottom").tickSize(0).innerTickSize(8 + ((this.viewport.height - this.margin.top - this.AxisSizeX) - xAxisTransform));
                    var getValueFn;
                    getValueFn = function (data) { return data; };
                    var yAxis = d3.svg.axis().scale(ys).orient("left").tickFormat(function (d) { return _this.formatY.format(getValueFn(d, _this.dataType)); }).ticks(yAxisTicks);
                    this.axisX.attr("transform", "translate(0, " + xAxisTransform + ")").transition().duration(duration).call(xAxis);
                    this.axisY.attr("transform", "translate(" + (this.AxisSizeY + this.margin.left) + ", 0)").transition().duration(duration).call(yAxis);
                    this.axisX.selectAll("text").style("font-size", this.getXAxisFontSize(this.dataView) + "px");
                    this.axisY.selectAll("text").style("font-size", this.getYAxisFontSize(this.dataView) + "px");
                    if (this.getShowMajorGridLines(this.dataView)) {
                        var yMajorGrid = d3.svg.axis().scale(ys).orient("left").ticks(yAxisTicks).outerTickSize(0).innerTickSize(-(this.viewport.width - this.AxisSizeY - this.margin.right - this.margin.left));
                        this.axisMajorGrid.attr("transform", "translate(" + (this.AxisSizeY + this.margin.left) + ", 0)").attr("opacity", 1).transition().duration(duration).call(yMajorGrid);
                        this.axisMajorGrid.selectAll("line").style("stroke", this.getColorMajorGridLines(this.dataView)).style("stroke-width", this.getSizeMajorGridLines(this.dataView));
                        if (this.getShowMinorGridLines(this.dataView)) {
                            var yMinorGrid = d3.svg.axis().scale(ys).orient("left").ticks(yAxisTicks * 5).outerTickSize(0).innerTickSize(-(this.viewport.width - this.AxisSizeY - this.margin.right + this.margin.left));
                            this.axisMinorGrid.attr("transform", "translate(" + (this.AxisSizeY + this.margin.left) + ", 0)").attr("opacity", 1).transition().duration(duration).call(yMinorGrid);
                            this.axisMinorGrid.selectAll("line").style("stroke", this.getColorMinorGridLines(this.dataView)).style("stroke-width", this.getSizeMinorGridLines(this.dataView));
                        }
                        else {
                            this.axisMinorGrid.attr("opacity", 0);
                        }
                    }
                    else {
                        this.axisMajorGrid.attr("opacity", 0);
                        this.axisMinorGrid.attr("opacity", 0);
                    }
                    //Cleanup labelhelpers
                    this.axisX.selectAll(".helperX").remove();
                    this.axisY.selectAll(".helperY").remove();
                };
                BoxWhiskerChart.prototype.drawChart = function (dataPoints, xScale, yScale, duration) {
                    var _this = this;
                    var dotRadius = 4, leftBoxMargin = 0.1;
                    if (!this.getDataLabelShow(this.dataView)) {
                        switch (this.getMarginType(this.dataView)) {
                            case 0 /* Small */:
                                leftBoxMargin = 0.05;
                                break;
                            case 1 /* Medium */:
                                leftBoxMargin = 0.1;
                                break;
                            case 2 /* Large */:
                                leftBoxMargin = 0.2;
                                break;
                            default:
                                leftBoxMargin = 0.1;
                                break;
                        }
                    }
                    var stack = d3.layout.stack();
                    var layers = stack(dataPoints);
                    var sm = this.selectionManager;
                    var selection = this.chart.selectAll(BoxWhiskerChart.ChartNode.selector).data(layers);
                    selection.enter().append('g').classed(BoxWhiskerChart.ChartNode.class, true);
                    var quartile = selection.selectAll(BoxWhiskerChart.ChartQuartileBox.selector).data(function (d) {
                        if (d && d.length > 0) {
                            return [d];
                        }
                        return [];
                    });
                    this.svg.on('click', function () { return _this.selectionManager.clear().then(function () { return quartile.style('opacity', 1); }); });
                    var fontSize = this.getDataLabelFontSize(this.dataView) + "px";
                    var dataLabelsShow = this.getDataLabelShow(this.dataView);
                    var dataLabelwidth = xScale.invert(xScale(0) + (Math.ceil(d3.max(dataPoints, function (value) {
                        return d3.max(value, function (point) {
                            return d3.max((point.dataLabels), function (dataLabel) {
                                return powerbi.TextMeasurementService.measureSvgTextWidth({
                                    text: _this.formatY.format(dataLabel.value),
                                    fontFamily: _this.defaultFontFamily,
                                    fontSize: PixelConverter.fromPoint(_this.getDataLabelFontSize(_this.dataView)),
                                });
                            });
                        });
                    }) * 10) / 10.));
                    if (dataLabelwidth > 0.8) {
                        dataLabelsShow = false;
                    }
                    var rightBoxMargin = 1. - (dataLabelsShow && (dataLabelwidth > leftBoxMargin) ? dataLabelwidth : leftBoxMargin);
                    var boxMiddle = dataLabelsShow ? leftBoxMargin + ((rightBoxMargin - leftBoxMargin) / 2.) : 0.5;
                    var quartileData = function (points) {
                        return points.map(function (value) {
                            var x1 = xScale(value.category + leftBoxMargin);
                            var x2 = xScale(value.category + boxMiddle);
                            var x3 = xScale(value.category + rightBoxMargin);
                            var y1 = yScale(value.min);
                            var y2 = value.samples <= 3 ? yScale(value.min) : yScale(value.quartile1);
                            var y3 = value.samples <= 3 ? yScale(value.max) : yScale(value.quartile3);
                            var y4 = yScale(value.max);
                            return "M " + x1 + "," + y1 + "L" + x3 + "," + y1 + "L" + x2 + "," + y1 + "L" + x2 + "," + y2 + " L" + x1 + "," + y2 + "L" + x1 + "," + y3 + "L" + x2 + "," + y3 + " L" + x2 + "," + y4 + "L" + x1 + "," + y4 + "L" + x3 + "," + y4 + "L" + x2 + "," + y4 + "L" + x2 + "," + y3 + " L" + x3 + "," + y3 + "L" + x3 + "," + y2 + "L" + x2 + "," + y2 + "L" + x2 + "," + y1;
                        }).join(' ');
                    };
                    var medianData = function (points) {
                        return points.map(function (value) {
                            var x1 = xScale(value.category + leftBoxMargin);
                            var y1 = yScale(value.median);
                            var x2 = xScale(value.category + rightBoxMargin);
                            var y2 = yScale(value.median);
                            return "M " + x1 + "," + y1 + " L" + x2 + "," + y2;
                        }).join(' ');
                    };
                    var avgData = function (points) {
                        return points.map(function (value) {
                            var x1 = xScale(value.category + boxMiddle);
                            var y1 = yScale(value.average);
                            var r = dotRadius;
                            var r2 = 2 * r;
                            return "M " + x1 + "," + y1 + " m -" + r + ", 0 a " + r + "," + r + " 0 1,1 " + r2 + ",0 a " + r + "," + r + " 0 1,1 -" + r2 + ",0";
                        }).join(' ');
                    };
                    var outlierData = function (points) {
                        return points.map(function (value) {
                            var x1 = xScale(value.category + boxMiddle);
                            var y1 = yScale(value.value);
                            var r = dotRadius;
                            var r2 = 2 * r;
                            return "M " + x1 + "," + y1 + " m -" + r + ", 0 a " + r + "," + r + " 0 1,1 " + r2 + ",0 a " + r + "," + r + " 0 1,1 -" + r2 + ",0";
                        }).join(' ');
                    };
                    quartile.enter().append('path').classed(BoxWhiskerChart.ChartQuartileBox.class, true);
                    quartile.style('fill', function (value) { return value[0].color; }).attr('opacity', 1).on('click', function (d) {
                        var _this = this;
                        sm.select(d[0].identity).then(function (ids) {
                            if (ids.length > 0) {
                                quartile.style('opacity', 0.5);
                                d3.select(_this).transition().duration(duration).style('opacity', 1);
                            }
                            else {
                                quartile.style('opacity', 1);
                            }
                        });
                        d3.event.stopPropagation();
                    }).style('stroke', function (value) { return value[0].color; }).style('stroke-width', 2).transition().duration(duration).attr('d', quartileData);
                    quartile.exit().remove();
                    var average = selection.selectAll(BoxWhiskerChart.ChartAverageDot.selector).data(function (d) {
                        if (d && d.length > 0) {
                            return [d];
                        }
                        return [];
                    });
                    average.enter().append('path').classed(BoxWhiskerChart.ChartAverageDot.class, true);
                    average.style('fill', 'black').transition().duration(duration).attr('d', avgData);
                    average.exit().remove();
                    var median = selection.selectAll(BoxWhiskerChart.ChartMedianLine.selector).data(function (d) {
                        if (d && d.length > 0) {
                            return [d];
                        }
                        return [];
                    });
                    median.enter().append('path').classed(BoxWhiskerChart.ChartMedianLine.class, true);
                    median.style('stroke', 'black').style('stroke-width', 2).transition().duration(duration).attr('d', medianData);
                    median.exit().remove();
                    var outliers = selection.selectAll(BoxWhiskerChart.ChartOutlierDot.selector).data(function (d) {
                        if (d[0].outliers && d[0].outliers.length > 0) {
                            return d[0].outliers.map(function (dataPoint) {
                                return [{
                                    category: d[0].category,
                                    color: d[0].color,
                                    value: dataPoint
                                }];
                            });
                        }
                        return [];
                    });
                    outliers.enter().append('path').classed(BoxWhiskerChart.ChartOutlierDot.class, true);
                    outliers.style('fill', function (value) { return value[0].color; }).transition().duration(duration).attr('d', outlierData);
                    outliers.exit().remove();
                    var dataLabels = selection.selectAll(BoxWhiskerChart.ChartDataLabel.selector).data(function (d) {
                        if (d[0].dataLabels && d[0].dataLabels.length > 0 && dataLabelsShow) {
                            var topLabels = d[0].dataLabels.filter(function (dataLabel) { return dataLabel.value >= d[0].median; }).sort(function (dataLabel1, dataLabel2) { return dataLabel1.value - dataLabel2.value; }); // Sort: median index 0
                            var lowerLabels = d[0].dataLabels.filter(function (dataLabel) { return dataLabel.value <= d[0].median; }).sort(function (dataLabel1, dataLabel2) { return dataLabel2.value - dataLabel1.value; }); // Sort: median index 0
                            var x = xScale(d[0].category + rightBoxMargin + 0.02);
                            topLabels[0].y = yScale(d[0].median) - 4;
                            topLabels[0].x = xScale(d[0].category + rightBoxMargin + 0.02);
                            lowerLabels[0].y = yScale(d[0].median) - 4;
                            lowerLabels[0].x = xScale(d[0].category + rightBoxMargin + 0.02);
                            var adjustment = 0;
                            var textHeight = (powerbi.TextMeasurementService.measureSvgTextHeight({
                                text: "XXXX",
                                fontFamily: _this.defaultFontFamily,
                                fontSize: PixelConverter.fromPoint(_this.getDataLabelFontSize(_this.dataView)),
                            }) / 2) + 1;
                            for (var i = 1; i < topLabels.length; i++) {
                                topLabels[i].y = yScale(topLabels[i].value) - 4;
                                topLabels[i].x = x;
                                var diff = Math.abs((topLabels[i].y + adjustment) - (topLabels[i - 1].y));
                                if (diff < textHeight) {
                                    adjustment += (textHeight - diff);
                                }
                                topLabels[i].y += adjustment;
                                if (diff >= textHeight) {
                                    adjustment = 0;
                                }
                            }
                            adjustment = 0;
                            for (var i = 1; i < lowerLabels.length; i++) {
                                lowerLabels[i].y = yScale(lowerLabels[i].value) - 4;
                                lowerLabels[i].x = x;
                                var diff = Math.abs((lowerLabels[i].y + adjustment) - lowerLabels[i - 1].y);
                                if (diff < textHeight) {
                                    adjustment -= (textHeight - diff);
                                }
                                lowerLabels[i].y += adjustment;
                                if (diff >= textHeight) {
                                    adjustment = 0;
                                }
                            }
                            var dataLabels = lowerLabels.concat(topLabels.filter(function (dataLabel) { return dataLabel.value > d[0].median; })).filter(function (dataLabel) { return dataLabel.x > 0; });
                            return dataLabels.map(function (dataPoint) {
                                return dataPoint;
                            });
                        }
                        return [];
                    });
                    dataLabels.enter().append("text").classed(BoxWhiskerChart.ChartDataLabel.class, true);
                    var y0 = this.viewport.height + this.AxisSizeX;
                    dataLabels.attr("transform", function (dataLabel) { return ("translate(0 " + y0 + ") scale(1, -1)"); }).transition().duration(duration).text(function (dataLabel) { return _this.formatY.format(dataLabel.value); }).attr("x", function (dataLabel) { return dataLabel.x; }).attr("y", function (dataLabel) { return y0 - dataLabel.y; }).attr("fill", "black");
                    this.chart.selectAll("text").style("font-size", fontSize);
                    dataLabels.exit().remove();
                    visuals.TooltipManager.addTooltip(quartile, function (tooltipEvent) {
                        return tooltipEvent.data[0].tooltipInfo;
                    }, true);
                    visuals.TooltipManager.addTooltip(median, function (tooltipEvent) {
                        return tooltipEvent.data[0].tooltipInfo;
                    }, true);
                    visuals.TooltipManager.addTooltip(average, function (tooltipEvent) {
                        return tooltipEvent.data[0].tooltipInfo;
                    }, true);
                    visuals.TooltipManager.addTooltip(outliers, function (tooltipEvent) {
                        return [{
                            displayName: "Outlier value",
                            value: tooltipEvent.data[0].value,
                        }];
                    }, true);
                    selection.exit().remove();
                };
                BoxWhiskerChart.prototype.getValueArray = function (nodes) {
                    var rArray = [];
                    for (var i = 0; i < 50000; i++) {
                        if (nodes[i] === undefined) {
                            break;
                        }
                        rArray.push(nodes[i].value);
                    }
                    return rArray;
                };
                BoxWhiskerChart.prototype.getAxisOptions = function (min, max) {
                    var min1 = min === 0 ? 0 : min > 0 ? (min * .99) - ((max - min) / 100) : (min * 1.01) - ((max - min) / 100);
                    var max1 = max === 0 ? min === 0 ? 1 : 0 : max < 0 ? (max * .99) + ((max - min) / 100) : (max * 1.01) + ((max - min) / 100);
                    var p = Math.log(max1 - min1) / Math.log(10);
                    var f = Math.pow(10, p - Math.floor(p));
                    var scale = 0.2;
                    if (f <= 1.2)
                        scale = 0.2;
                    else if (f <= 2.5)
                        scale = 0.2;
                    else if (f <= 5)
                        scale = 0.5;
                    else if (f <= 10)
                        scale = 1;
                    else
                        scale = 2;
                    var tickSize = scale * Math.pow(10, Math.floor(p));
                    var maxValue = tickSize * (Math.floor(max1 / tickSize) + 1);
                    var minValue = tickSize * Math.floor(min1 / tickSize);
                    var ticks = ((maxValue - minValue) / tickSize) + 1;
                    return {
                        tickSize: tickSize,
                        max: maxValue,
                        min: minValue,
                        ticks: ticks,
                    };
                };
                BoxWhiskerChart.prototype.getWhiskerType = function (dataView) {
                    return powerbi.DataViewObjects.getValue(this.dataView.metadata.objects, BoxWhiskerChart.properties.whiskerType, 0 /* MinMax */);
                };
                BoxWhiskerChart.prototype.getMarginType = function (dataView) {
                    return powerbi.DataViewObjects.getValue(this.dataView.metadata.objects, BoxWhiskerChart.properties.marginType, 1 /* Medium */);
                };
                BoxWhiskerChart.prototype.getShowOutliers = function (dataView) {
                    return dataView.metadata && powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.showOutliers, false);
                };
                BoxWhiskerChart.prototype.getStaticColor = function (dataView) {
                    return powerbi.DataViewObjects.getFillColor(dataView.metadata.objects, BoxWhiskerChart.properties.fill, "#01b8aa");
                };
                BoxWhiskerChart.prototype.getXAxisFontSize = function (dataView) {
                    return powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.fontSizeXAxis, 11);
                };
                BoxWhiskerChart.prototype.getYAxisFontSize = function (dataView) {
                    return powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.fontSizeYAxis, 11);
                };
                BoxWhiskerChart.prototype.getShowMajorGridLines = function (dataView) {
                    return dataView.metadata && powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.showMajorGridLines, true);
                };
                BoxWhiskerChart.prototype.getSizeMajorGridLines = function (dataView) {
                    return powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.sizeMajorGridLines, 1);
                };
                BoxWhiskerChart.prototype.getColorMajorGridLines = function (dataView) {
                    return powerbi.DataViewObjects.getFillColor(dataView.metadata.objects, BoxWhiskerChart.properties.colorMajorGridLines, "#666666");
                };
                BoxWhiskerChart.prototype.getShowMinorGridLines = function (dataView) {
                    return dataView.metadata && powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.showMinorGridLines, false);
                };
                BoxWhiskerChart.prototype.getSizeMinorGridLines = function (dataView) {
                    return powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.sizeMinorGridLines, 1);
                };
                BoxWhiskerChart.prototype.getColorMinorGridLines = function (dataView) {
                    return powerbi.DataViewObjects.getFillColor(dataView.metadata.objects, BoxWhiskerChart.properties.colorMinorGridLines, "#9c9c9c");
                };
                BoxWhiskerChart.prototype.getDataLabelShow = function (dataView) {
                    return powerbi.DataViewObjects.getValue(this.dataView.metadata.objects, BoxWhiskerChart.properties.dataLabelShow, false);
                };
                BoxWhiskerChart.prototype.getDataLabelFontSize = function (dataView) {
                    return powerbi.DataViewObjects.getValue(dataView.metadata.objects, BoxWhiskerChart.properties.dataLabelFontSize, 11);
                };
                BoxWhiskerChart.prototype.enumerateObjectInstances = function (options) {
                    var instances = [];
                    switch (options.objectName) {
                        case "chartOptions":
                            var chartOptions = {
                                objectName: "chartOptions",
                                displayName: "Chart Options",
                                selector: null,
                                properties: {
                                    whisker: this.getWhiskerType(this.dataView),
                                    outliers: this.getShowOutliers(this.dataView),
                                    margin: this.getMarginType(this.dataView),
                                }
                            };
                            instances.push(chartOptions);
                            break;
                        case "dataPoint":
                            var categories = this.dataView.matrix.rows.root.children;
                            if (categories.length > 25) {
                                var dataPoint = {
                                    objectName: "dataPoint",
                                    displayName: "Fill color",
                                    selector: null,
                                    properties: {
                                        fill: { solid: { color: this.getStaticColor(this.dataView) } }
                                    }
                                };
                                instances.push(dataPoint);
                            }
                            else {
                                for (var i = 0; i < categories.length; i++) {
                                    var dataPoint = {
                                        objectName: "dataPoint",
                                        displayName: this.data.dataPoints[i][0].label,
                                        selector: visuals.ColorHelper.normalizeSelector(this.data.dataPoints[i][0].identity.getSelector(), true),
                                        properties: {
                                            fill: { solid: { color: this.data.dataPoints[i][0].color } }
                                        }
                                    };
                                    instances.push(dataPoint);
                                }
                            }
                            break;
                        case "xAxis":
                            var xAxis = {
                                objectName: "xAxis",
                                displayName: "X-Axis",
                                selector: null,
                                properties: {
                                    fontSize: this.getXAxisFontSize(this.dataView),
                                }
                            };
                            instances.push(xAxis);
                            break;
                        case "yAxis":
                            var yAxis = {
                                objectName: "yAxis",
                                displayName: "Y-Axis",
                                selector: null,
                                properties: {
                                    fontSize: this.getYAxisFontSize(this.dataView),
                                }
                            };
                            instances.push(yAxis);
                            break;
                        case "gridLines":
                            var gridLines = {
                                objectName: "gridLines",
                                displayName: "Grid lines",
                                selector: null,
                                properties: {
                                    majorGrid: this.getShowMajorGridLines(this.dataView),
                                    majorGridSize: this.getSizeMajorGridLines(this.dataView),
                                    majorGridColor: { solid: { color: this.getColorMajorGridLines(this.dataView) } },
                                    minorGrid: this.getShowMinorGridLines(this.dataView),
                                    minorGridSize: this.getSizeMinorGridLines(this.dataView),
                                    minorGridColor: { solid: { color: this.getColorMinorGridLines(this.dataView) } },
                                }
                            };
                            instances.push(gridLines);
                            break;
                        case "labels":
                            var labels = {
                                objectName: "labels",
                                displayName: "Data labels",
                                selector: null,
                                properties: {
                                    show: this.getDataLabelShow(this.dataView),
                                    fontSize: this.getDataLabelFontSize(this.dataView),
                                }
                            };
                            instances.push(labels);
                            break;
                        case "privacy":
                            var privacy = {
                                objectName: "privacy",
                                displayName: "Privacy",
                                selector: null,
                                properties: {
                                    updates: false,
                                    version: "0.12.03",
                                }
                            };
                            instances.push(privacy);
                            break;
                    }
                    return instances;
                };
                BoxWhiskerChart.capabilities = {
                    dataRoles: [
                        {
                            name: 'Groups',
                            kind: powerbi.VisualDataRoleKind.Grouping,
                            displayName: 'Category'
                        },
                        {
                            name: 'Samples',
                            kind: powerbi.VisualDataRoleKind.Grouping,
                            displayName: 'Sampling'
                        },
                        {
                            name: 'Values',
                            kind: powerbi.VisualDataRoleKind.Measure,
                            displayName: 'Values'
                        },
                    ],
                    dataViewMappings: [{
                        conditions: [
                            { 'Groups': { min: 0, max: 1 }, 'Values': { min: 0, max: 1 } },
                        ],
                        matrix: {
                            rows: {
                                for: { in: 'Groups' },
                                dataReductionAlgorithm: { top: { count: 100 } }
                            },
                            columns: {
                                for: { in: 'Samples' },
                                dataReductionAlgorithm: { top: { count: 50000 } }
                            },
                            values: {
                                for: { in: 'Values' }
                            },
                        }
                    }],
                    objects: {
                        general: {
                            displayName: 'General',
                            properties: {
                                formatString: {
                                    type: { formatting: { formatString: true } },
                                },
                            },
                        },
                        chartOptions: {
                            displayName: "Chart Options",
                            properties: {
                                whisker: {
                                    displayName: "Chart type",
                                    description: "Determines the type of box and whisker chart",
                                    type: {
                                        enumeration: powerbi.createEnumType([
                                            { value: 0 /* MinMax */, displayName: "Min/Max" },
                                            { value: 1 /* Standard */, displayName: "Tukey" },
                                            { value: 2 /* IQR */, displayName: "1.5 IQR" }
                                        ])
                                    }
                                },
                                outliers: {
                                    displayName: "Outliers",
                                    description: "Show outliers",
                                    type: { bool: true }
                                },
                                margin: {
                                    displayName: "Chart margin",
                                    description: "The margin between the different boxes.\nOnly used when no datalabels are shown",
                                    type: {
                                        enumeration: powerbi.createEnumType([
                                            { value: 0 /* Small */, displayName: "Small" },
                                            { value: 1 /* Medium */, displayName: "Medium" },
                                            { value: 2 /* Large */, displayName: "Large" }
                                        ])
                                    }
                                },
                            }
                        },
                        dataPoint: {
                            displayName: "Data colors",
                            properties: {
                                fill: {
                                    displayName: "Fill",
                                    type: { fill: { solid: { color: true } } }
                                }
                            }
                        },
                        xAxis: {
                            displayName: "X-Axis",
                            properties: {
                                fontSize: {
                                    displayName: "Text Size",
                                    type: { formatting: { fontSize: true } }
                                },
                            }
                        },
                        yAxis: {
                            displayName: "Y-Axis",
                            properties: {
                                fontSize: {
                                    displayName: "Text Size",
                                    type: { formatting: { fontSize: true } }
                                },
                            }
                        },
                        gridLines: {
                            displayName: "Gridlines",
                            properties: {
                                majorGrid: {
                                    displayName: "Major grid",
                                    description: "Display major gridlines",
                                    type: { bool: true }
                                },
                                majorGridSize: {
                                    displayName: "Thickness",
                                    description: "Thickness of the major gridlines",
                                    type: { numeric: true }
                                },
                                majorGridColor: {
                                    displayName: "Color",
                                    description: "Color of the major gridlines",
                                    type: { fill: { solid: { color: true } } }
                                },
                                minorGrid: {
                                    displayName: "Minor grid",
                                    description: "Display minor gridlines",
                                    type: { bool: true }
                                },
                                minorGridSize: {
                                    displayName: "Thickness",
                                    description: "Thickness of the minor gridlines",
                                    type: { numeric: true }
                                },
                                minorGridColor: {
                                    displayName: "Color",
                                    description: "Color of the minor gridlines",
                                    type: { fill: { solid: { color: true } } }
                                },
                            }
                        },
                        labels: {
                            displayName: "Data labels",
                            properties: {
                                show: {
                                    displayName: "Show",
                                    type: { bool: true }
                                },
                                fontSize: {
                                    displayName: "Text Size",
                                    type: { formatting: { fontSize: true } },
                                    description: "If datalabels are to big, the default size is used.",
                                },
                            }
                        },
                        privacy: {
                            displayName: "Privacy",
                            properties: {
                                version: {
                                    displayName: "Version",
                                    type: { text: true },
                                    placeHolderText: "Placeholder",
                                },
                            },
                        }
                    }
                };
                BoxWhiskerChart.properties = {
                    formatString: { objectName: "general", propertyName: "formatString" },
                    whiskerType: { objectName: "chartOptions", propertyName: "whisker" },
                    marginType: { objectName: "chartOptions", propertyName: "margin" },
                    fontSizeXAxis: { objectName: "xAxis", propertyName: "fontSize" },
                    fontSizeYAxis: { objectName: "yAxis", propertyName: "fontSize" },
                    showOutliers: { objectName: "chartOptions", propertyName: "outliers" },
                    showMajorGridLines: { objectName: "gridLines", propertyName: "majorGrid" },
                    sizeMajorGridLines: { objectName: "gridLines", propertyName: "majorGridSize" },
                    colorMajorGridLines: { objectName: "gridLines", propertyName: "majorGridColor" },
                    showMinorGridLines: { objectName: "gridLines", propertyName: "minorGrid" },
                    sizeMinorGridLines: { objectName: "gridLines", propertyName: "minorGridSize" },
                    colorMinorGridLines: { objectName: "gridLines", propertyName: "minorGridColor" },
                    fill: { objectName: "dataPoint", propertyName: "fill" },
                    dataLabelShow: { objectName: "labels", propertyName: "show" },
                    dataLabelFontSize: { objectName: "labels", propertyName: "fontSize" },
                };
                BoxWhiskerChart.LocalizationStrings = {
                    get: function (stringId) { return stringId; },
                    getOptional: function (stringId) { return stringId; }
                };
                BoxWhiskerChart.formatStringProp = {
                    objectName: "general",
                    propertyName: "formatString",
                };
                BoxWhiskerChart.VisualClassName = "boxWhiskerChart";
                BoxWhiskerChart.Axis = { class: "axis", selector: ".axis" };
                BoxWhiskerChart.AxisX = { class: "axisX", selector: ".axisX" };
                BoxWhiskerChart.AxisMajorGrid = { class: "axisMajorGrid", selector: ".axisMajorGrid" };
                BoxWhiskerChart.AxisMinorGrid = { class: "axisMinorGrid", selector: ".axisMinorGrid" };
                BoxWhiskerChart.AxisY = { class: "axisY", selector: ".axisY" };
                BoxWhiskerChart.Chart = { class: "chart", selector: ".chart" };
                BoxWhiskerChart.ChartNode = { class: 'chartNode', selector: '.chartNode' };
                BoxWhiskerChart.ChartQuartileBox = { class: 'chartQuartileBox', selector: '.chartQuartileBox' };
                BoxWhiskerChart.ChartMedianLine = { class: 'chartMedianLine', selector: '.chartMedianLine' };
                BoxWhiskerChart.ChartAverageDot = { class: 'chartAverageDot', selector: '.chartAverageDot' };
                BoxWhiskerChart.ChartOutlierDot = { class: 'chartOutlierDot', selector: '.chartOutlierDot' };
                BoxWhiskerChart.ChartDataLabel = { class: "chartDataLabel", selector: ".chartDataLabel" };
                BoxWhiskerChart.DefaultMargin = {
                    top: 5,
                    bottom: 5,
                    right: 5,
                    left: 5
                };
                return BoxWhiskerChart;
            })();
            BoxWhiskerChart1455240051538.BoxWhiskerChart = BoxWhiskerChart;
        })(BoxWhiskerChart1455240051538 = visuals.BoxWhiskerChart1455240051538 || (visuals.BoxWhiskerChart1455240051538 = {}));
    })(visuals = powerbi.visuals || (powerbi.visuals = {}));
})(powerbi || (powerbi = {}));
var powerbi;
(function (powerbi) {
    var visuals;
    (function (visuals) {
        var plugins;
        (function (plugins) {
            plugins.BoxWhiskerChart1455240051538 = {
                name: 'BoxWhiskerChart1455240051538',
                class: 'BoxWhiskerChart1455240051538',
                capabilities: powerbi.visuals.BoxWhiskerChart1455240051538.BoxWhiskerChart.capabilities,
                custom: true,
                create: function (options) { return new powerbi.visuals.BoxWhiskerChart1455240051538.BoxWhiskerChart(options); },
                apiVersion: null
            };
        })(plugins = visuals.plugins || (visuals.plugins = {}));
    })(visuals = powerbi.visuals || (powerbi.visuals = {}));
})(powerbi || (powerbi = {}));
